import _concat from "lodash/concat";
import _mergeWith2 from "lodash/mergeWith";
import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _isFunction from "lodash/isFunction";
import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
var _excluded = ["fetch", "sandbox", "globalContext"];
import _regeneratorRuntime from "@babel/runtime/regenerator";
/**
 * @author Kuitos
 * @since 2023-04-25
 */

import { loadEntry } from '@qiankunjs/loader';
import { createSandboxContainer } from '@qiankunjs/sandbox';
import { wrapFetchWithCache } from '@qiankunjs/shared';
import getAddOns from "../addons";
import { QiankunError } from "../error";
import { getPureHTMLStringWithoutScripts, performanceGetEntriesByName, performanceMark, performanceMeasure, toArray } from "../utils";
import { version } from "../version";
export default function loadApp(_x, _x2, _x3) {
  return _loadApp.apply(this, arguments);
}
function _loadApp() {
  _loadApp = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee12(app, configuration, lifeCycles) {
    var _sandboxInstance;
    var appName, entry, container, _ref2, _ref2$fetch, fetch, sandbox, _ref2$globalContext, globalContext, restConfiguration, fetchWithLruCache, markName, global, mountSandbox, unmountSandbox, sandboxInstance, sandboxMicroAppContainer, sandboxContainer, containerOpts, lifecyclesPromise, assetPublicPath, _mergeWith, _mergeWith$beforeUnmo, beforeUnmount, _mergeWith$afterUnmou, afterUnmount, _mergeWith$afterMount, afterMount, _mergeWith$beforeMoun, beforeMount, _mergeWith$beforeLoad, beforeLoad, lifecycles, _getLifecyclesFromExp, bootstrap, mount, unmount, update, mountTimes;
    return _regeneratorRuntime.wrap(function _callee12$(_context12) {
      while (1) switch (_context12.prev = _context12.next) {
        case 0:
          appName = app.name, entry = app.entry, container = app.container;
          _ref2 = configuration || {}, _ref2$fetch = _ref2.fetch, fetch = _ref2$fetch === void 0 ? window.fetch : _ref2$fetch, sandbox = _ref2.sandbox, _ref2$globalContext = _ref2.globalContext, globalContext = _ref2$globalContext === void 0 ? window : _ref2$globalContext, restConfiguration = _objectWithoutProperties(_ref2, _excluded);
          fetchWithLruCache = wrapFetchWithCache(fetch);
          markName = "[qiankun] App ".concat(appName, " Loading");
          if (process.env.NODE_ENV === 'development') {
            performanceMark(markName);
          }
          global = globalContext;
          mountSandbox = function mountSandbox() {
            return Promise.resolve();
          };
          unmountSandbox = function unmountSandbox() {
            return Promise.resolve();
          };
          sandboxMicroAppContainer = container;
          initContainer(sandboxMicroAppContainer, appName, sandbox);
          if (sandbox) {
            sandboxContainer = createSandboxContainer(appName, function () {
              return sandboxMicroAppContainer;
            }, {
              globalContext: globalContext,
              extraGlobals: {},
              fetch: fetchWithLruCache,
              nodeTransformer: restConfiguration.nodeTransformer
            });
            sandboxInstance = sandboxContainer.instance;
            global = sandboxInstance.globalThis;
            mountSandbox = function mountSandbox() {
              return sandboxContainer.mount();
            };
            unmountSandbox = function unmountSandbox() {
              return sandboxContainer.unmount();
            };
          }
          containerOpts = _objectSpread({
            fetch: fetchWithLruCache,
            sandbox: sandboxInstance
          }, restConfiguration);
          lifecyclesPromise = loadEntry(entry, sandboxMicroAppContainer, containerOpts);
          assetPublicPath = calcPublicPath(entry);
          _mergeWith = _mergeWith2({}, getAddOns(global, assetPublicPath), lifeCycles, function (v1, v2) {
            return _concat(v1 !== null && v1 !== void 0 ? v1 : [], v2 !== null && v2 !== void 0 ? v2 : []);
          }), _mergeWith$beforeUnmo = _mergeWith.beforeUnmount, beforeUnmount = _mergeWith$beforeUnmo === void 0 ? [] : _mergeWith$beforeUnmo, _mergeWith$afterUnmou = _mergeWith.afterUnmount, afterUnmount = _mergeWith$afterUnmou === void 0 ? [] : _mergeWith$afterUnmou, _mergeWith$afterMount = _mergeWith.afterMount, afterMount = _mergeWith$afterMount === void 0 ? [] : _mergeWith$afterMount, _mergeWith$beforeMoun = _mergeWith.beforeMount, beforeMount = _mergeWith$beforeMoun === void 0 ? [] : _mergeWith$beforeMoun, _mergeWith$beforeLoad = _mergeWith.beforeLoad, beforeLoad = _mergeWith$beforeLoad === void 0 ? [] : _mergeWith$beforeLoad; // FIXME Due to the asynchronous execution of loadEntry, the DOM of the sub-app is inserted synchronously through appendChild, and inline scripts are also executed synchronously. Therefore, the beforeLoad may need to rely on transformer configuration to coordinate and ensure the order of asynchronous operations.
          _context12.next = 17;
          return execHooksChain(toArray(beforeLoad), app, global);
        case 17:
          _context12.next = 19;
          return lifecyclesPromise;
        case 19:
          lifecycles = _context12.sent;
          if (lifecycles) {
            _context12.next = 22;
            break;
          }
          throw new QiankunError("".concat(appName, " entry ").concat(entry, " load failed as it not export lifecycles"));
        case 22:
          _getLifecyclesFromExp = getLifecyclesFromExports(lifecycles, appName, global, (_sandboxInstance = sandboxInstance) === null || _sandboxInstance === void 0 ? void 0 : _sandboxInstance.latestSetProp), bootstrap = _getLifecyclesFromExp.bootstrap, mount = _getLifecyclesFromExp.mount, unmount = _getLifecyclesFromExp.unmount, update = _getLifecyclesFromExp.update;
          mountTimes = 1;
          return _context12.abrupt("return", function (mountContainer) {
            var parcelConfig = {
              name: appName,
              // eslint-disable-next-line @typescript-eslint/ban-ts-comment
              // @ts-ignore
              bootstrap: bootstrap,
              mount: [/*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
                var marks;
                return _regeneratorRuntime.wrap(function _callee$(_context) {
                  while (1) switch (_context.prev = _context.next) {
                    case 0:
                      if (process.env.NODE_ENV === 'development') {
                        marks = performanceGetEntriesByName(markName, 'mark'); // mark length is zero means the app is remounting
                        if (marks && !marks.length) {
                          performanceMark(markName);
                        }
                      }
                    case 1:
                    case "end":
                      return _context.stop();
                  }
                }, _callee);
              })), /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2() {
                var htmlString;
                return _regeneratorRuntime.wrap(function _callee2$(_context2) {
                  while (1) switch (_context2.prev = _context2.next) {
                    case 0:
                      sandboxMicroAppContainer = mountContainer;

                      // while the micro app is remounting, we need to load the entry manually
                      if (!(mountTimes > 1)) {
                        _context2.next = 8;
                        break;
                      }
                      initContainer(mountContainer, appName, sandbox);
                      // html scripts should be removed to avoid repeatedly execute
                      _context2.next = 5;
                      return getPureHTMLStringWithoutScripts(entry, fetchWithLruCache);
                    case 5:
                      htmlString = _context2.sent;
                      _context2.next = 8;
                      return loadEntry(htmlString, mountContainer, containerOpts);
                    case 8:
                    case "end":
                      return _context2.stop();
                  }
                }, _callee2);
              })), mountSandbox,
              /*#__PURE__*/
              // exec the chain after rendering to keep the behavior with beforeLoad
              _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee3() {
                return _regeneratorRuntime.wrap(function _callee3$(_context3) {
                  while (1) switch (_context3.prev = _context3.next) {
                    case 0:
                      return _context3.abrupt("return", execHooksChain(toArray(beforeMount), app, global));
                    case 1:
                    case "end":
                      return _context3.stop();
                  }
                }, _callee3);
              })), /*#__PURE__*/function () {
                var _ref6 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee4(props) {
                  return _regeneratorRuntime.wrap(function _callee4$(_context4) {
                    while (1) switch (_context4.prev = _context4.next) {
                      case 0:
                        return _context4.abrupt("return", mount(_objectSpread(_objectSpread({}, props), {}, {
                          container: mountContainer
                        })));
                      case 1:
                      case "end":
                        return _context4.stop();
                    }
                  }, _callee4);
                }));
                return function (_x4) {
                  return _ref6.apply(this, arguments);
                };
              }(),
              /*#__PURE__*/
              // finish loading after app mounted
              _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee5() {
                return _regeneratorRuntime.wrap(function _callee5$(_context5) {
                  while (1) switch (_context5.prev = _context5.next) {
                    case 0:
                      return _context5.abrupt("return", execHooksChain(toArray(afterMount), app, global));
                    case 1:
                    case "end":
                      return _context5.stop();
                  }
                }, _callee5);
              })), /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee6() {
                var measureName;
                return _regeneratorRuntime.wrap(function _callee6$(_context6) {
                  while (1) switch (_context6.prev = _context6.next) {
                    case 0:
                      if (process.env.NODE_ENV === 'development') {
                        measureName = "[qiankun] App ".concat(appName, " Loading Consuming");
                        performanceMeasure(measureName, markName);
                      }
                    case 1:
                    case "end":
                      return _context6.stop();
                  }
                }, _callee6);
              })), /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee7() {
                return _regeneratorRuntime.wrap(function _callee7$(_context7) {
                  while (1) switch (_context7.prev = _context7.next) {
                    case 0:
                      mountTimes++;
                    case 1:
                    case "end":
                      return _context7.stop();
                  }
                }, _callee7);
              }))],
              unmount: [/*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee8() {
                return _regeneratorRuntime.wrap(function _callee8$(_context8) {
                  while (1) switch (_context8.prev = _context8.next) {
                    case 0:
                      return _context8.abrupt("return", execHooksChain(toArray(beforeUnmount), app, global));
                    case 1:
                    case "end":
                      return _context8.stop();
                  }
                }, _callee8);
              })), /*#__PURE__*/function () {
                var _ref11 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee9(props) {
                  return _regeneratorRuntime.wrap(function _callee9$(_context9) {
                    while (1) switch (_context9.prev = _context9.next) {
                      case 0:
                        return _context9.abrupt("return", unmount(_objectSpread(_objectSpread({}, props), {}, {
                          container: mountContainer
                        })));
                      case 1:
                      case "end":
                        return _context9.stop();
                    }
                  }, _callee9);
                }));
                return function (_x5) {
                  return _ref11.apply(this, arguments);
                };
              }(), unmountSandbox, /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee10() {
                return _regeneratorRuntime.wrap(function _callee10$(_context10) {
                  while (1) switch (_context10.prev = _context10.next) {
                    case 0:
                      return _context10.abrupt("return", execHooksChain(toArray(afterUnmount), app, global));
                    case 1:
                    case "end":
                      return _context10.stop();
                  }
                }, _callee10);
              })), /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee11() {
                return _regeneratorRuntime.wrap(function _callee11$(_context11) {
                  while (1) switch (_context11.prev = _context11.next) {
                    case 0:
                      clearContainer(mountContainer);
                    case 1:
                    case "end":
                      return _context11.stop();
                  }
                }, _callee11);
              }))]
            };
            if (typeof update === 'function') {
              // eslint-disable-next-line @typescript-eslint/ban-ts-comment
              // @ts-ignore
              parcelConfig.update = update;
            }
            return parcelConfig;
          });
        case 25:
        case "end":
          return _context12.stop();
      }
    }, _callee12);
  }));
  return _loadApp.apply(this, arguments);
}
function initContainer(container, appName, sandboxCfg) {
  while (container.firstChild) {
    container.removeChild(container.firstChild);
  }
  container.dataset.name = appName;
  container.dataset.version = version;
  container.dataset.sandboxCfg = JSON.stringify(sandboxCfg);
}
function clearContainer(container) {
  while (container.firstChild) {
    container.removeChild(container.firstChild);
  }
}
function execHooksChain(hooks, app) {
  var global = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : window;
  if (hooks.length) {
    return hooks.reduce(function (chain, hook) {
      return chain.then(function () {
        return hook(app, global);
      });
    }, Promise.resolve());
  }
  return Promise.resolve();
}
function getLifecyclesFromExports(scriptExports, appName, globalContext, globalLatestSetProp) {
  var validateExportLifecycle = function validateExportLifecycle(exports) {
    var _ref = exports !== null && exports !== void 0 ? exports : {},
      bootstrap = _ref.bootstrap,
      mount = _ref.mount,
      unmount = _ref.unmount;
    return _isFunction(bootstrap) && _isFunction(mount) && _isFunction(unmount);
  };
  if (validateExportLifecycle(scriptExports)) {
    return scriptExports;
  }

  // fallback to sandbox latest set property if it had
  if (globalLatestSetProp) {
    var lifecycles = globalContext[globalLatestSetProp];
    if (validateExportLifecycle(lifecycles)) {
      return lifecycles;
    }
  }
  if (process.env.NODE_ENV === 'development') {
    console.warn("[qiankun] lifecycle not found from ".concat(appName, " entry exports, fallback to get from window['").concat(appName, "']"));
  }

  // fallback to globalContext variable who named with ${appName} while module exports not found
  var globalVariableExports = globalContext[appName];
  if (validateExportLifecycle(globalVariableExports)) {
    return globalVariableExports;
  }
  throw new QiankunError("You need to export lifecycle functions in ".concat(appName, " entry"));
}
function calcPublicPath(entry) {
  try {
    var _URL = new URL(entry, location.href),
      origin = _URL.origin,
      pathname = _URL.pathname;
    var paths = pathname.split('/');
    paths.pop();
    return "".concat(origin).concat(paths.join('/'), "/");
  } catch (e) {
    console.warn(e);
    return '';
  }
}
//# sourceMappingURL=loadApp.js.map